#!/usr/bin/env python
#Transmission and reception, one ata a time on the same antena

from gnuradio import gr, gru, modulation_utils
from gnuradio import eng_notation
##########spectrum sense specific imports
from gnuradio import optfir, window
from gnuradio import usrp
#from gnuradio.eng_option import eng_option
#from usrpm import usrp_dbid
##########
from gnuradio.eng_option import eng_option
from optparse import OptionParser
from numpy import random
import random, time, struct, sys, math

# from current dir
from transmit_path import transmit_path
from receive_path import receive_path
#import spec_sense_path

global sync_status
sync_status = False #default value is "False"...
global mode
#Defining modes of operation
#sync = synchronizing with other node before data transfer
#traffic = data transfer
#spec_sense = sensing spectrum for primary user
mode = "sync" #default mode of operation...
class my_top_block(gr.top_block):

    def __init__(self, mod_class, demod_class,
                 rx_callback, options_tx,options_rx):

        gr.top_block.__init__(self)
        self.rxpath = receive_path(demod_class, rx_callback, options_rx)
	self.txpath = transmit_path(mod_class, options_tx)
	self.connect(self.txpath);
	self.connect(self.rxpath);

	
#//////main//////  

global n_rcvd, n_right,hop_freq

def main():
    global n_rcvd, n_right,sync_status,mode,hop_freq
    n_rcvd = 0
    n_right = 0
    def send_pkt(self, payload='', eof=False):
        return self.txpath.send_pkt(payload, eof)

    def rx_callback(ok, payload):

	
        #print "inside rx callback"
        global n_rcvd, n_right, sync_status,mode,hop_freq
	#tb.rxpath.min_freq = hop_freq - 80e3 
        #tb.rxpath.max_freq = hop_freq + 80e3 
	#tb.rxpath.get_spec_stats(1e13,20,2)
        (pktno,) = struct.unpack('!H', payload[0:2])
        #temp = struct.unpack('!s', payload[3:10])
	#print "printing the elements of packet",temp,"!!!!!!!!!!!\n"
        #####################################################
	if mode == "sync":
		(sync_signal,) = struct.unpack('!s', payload[2]) 
        	(sync_signal_red,) = struct.unpack('!s', payload[3])  #redundant sync bit
        	(data_channel,) = struct.unpack('!s', payload[4])
        	(data_channel_red,) = struct.unpack('!s', payload[5])  #redundant channel bit
        	#print "printing the elements of packet  ",sync_signal,"  !!!!!!!!!!!  ",sync_signal_red," !!!!!\n"    
        	#print "printing the channel  ",data_channel_red,"  !!!!!!!!!!!  ",data_channel_red," !!!!!\n"
        	if ok: #== True :# and str(sync_signal) == 'o' and str(sync_signal_red) == 'o':
            		#print "inside if"
            		if ok: #== True: #str(data_channel) == str(data_channel_red):
                		#print "inside if1$$$$$"
                		if str(data_channel) == str(ch):
                    			#print "inside if2"
                    			sync_status = True
		    			#tb.stop()
		    			#print "after tb stop ans sync status is ",sync_status," sync status\n"
                    			#print "received a sync packet on channel %s\n" %(data_channel)
                    			#data = 'o'+'o'+str(data_channel)+str(data_channel)
                    			#print "sending this data",data,"@@@@@\n"
                    			#sync_pktno=0
                    			#ack_payload = struct.pack('!H', sync_pktno & 0xffff) + data
                    			#print "printing the ack packet",ack_payload,"$$$$$\n"
                    			#k=0
                    			#while k < 10000:
                    			#print "inside while"
                    			#send_pkt(tb,ack_payload) #sending back the acknowledgement
                    			#k=k+1
	#####################################################
	
	######################### traffic ############################
	if mode == "traffic":
		if ok == True:
			comm = struct.unpack('!14s', data)
			print("received this ", comm) 
	
	##############################################################
	


        n_rcvd += 1
        if ok:
            n_right += 1

        #print "ok = %5s  pktno = %4d  n_rcvd = %4d  n_right = %4d" % (
            #ok, pktno, n_rcvd, n_right)

    mods = modulation_utils.type_1_mods()
    demods = modulation_utils.type_1_demods()

    #setting up the tx options parser
    parser_tx = OptionParser(option_class=eng_option, conflict_handler="resolve")
    expert_grp_tx = parser_tx.add_option_group("Expert_tx")
    print "printing Expert_tx group",expert_grp_tx,"printing Expert_tx group"
    parser_tx.add_option("-m", "--modulation", type="choice", choices=mods.keys(),
                      default='gmsk',
                      help="Select modulation from: %s [default=%%default]"
                            % (', '.join(mods.keys()),))

    parser_tx.add_option("-s", "--size", type="eng_float", default=1500,
                      help="set packet size [default=%default]")
    parser_tx.add_option("-M", "--megabytes", type="eng_float", default=1.0,
                      help="set megabytes to transmit [default=%default]")
    parser_tx.add_option("","--discontinuous", action="store_true", default=False,
                      help="enable discontinous transmission (bursts of 5 packets)")
    parser_tx.add_option("","--from-file", default=None,
                      help="use file for packet contents")
    print "printing parser_tx",parser_tx,"printing parser_tx"
    transmit_path.add_options(parser_tx, expert_grp_tx)

    for mod in mods.values():
        mod.add_options(expert_grp_tx)

    (options_tx, args_tx) = parser_tx.parse_args ()

    if len(args_tx) != 0:
        parser_tx.print_help()
        sys.exit(1)
    ############# Setting some default values for tx side of the block
    options_tx.tx_freq = 462.5625e6 
    options_tx.samples_per_symbol =  2
    options_tx.modulation = 'dbpsk'
    options_tx.fusb_block_size = 4096
    options_tx.fusb_nblocks = 16
    options_tx.bitrate = 0.0125e6
    #############
    if options_tx.tx_freq is None:
        sys.stderr.write("You must specify -f FREQ or --freq FREQ\n")
        parser_tx.print_help(sys.stderr)
        sys.exit(1)

    if options_tx.from_file is not None:
        source_file = open(options_tx.from_file, 'r')
    print "printing modulation type",mods[options_tx.modulation],"**"
    # build the graph
    print "printing tx options",options_tx,"&&&&\n"
    #tb = my_top_block(mods[options_tx.modulation], options_tx)

    #r = gr.enable_realtime_scheduling()
    #if r != gr.RT_OK:
    #   print "Warning: failed to enable realtime scheduling"

    #setting up rx options parser
    
    # Create Options Parser:
    parser_rx = OptionParser (option_class=eng_option, conflict_handler="resolve")
    print "printing parser_rx",parser_rx,"!!!!!\n"
    print "after option parser"
    expert_grp_rx = parser_rx.add_option_group("Expert_rx")
    print "printing expert group rx",expert_grp_rx,"@@@@\n"
    parser_rx.add_option("-m", "--modulation", type="choice", choices=demods.keys(), 
                      default='gmsk',
                      help="Select modulation from: %s [default=%%default]"
                            % (', '.join(demods.keys()),))
    print "inside rx option parser"
    receive_path.add_options(parser_rx, expert_grp_rx)

    for mod in demods.values():
        mod.add_options(expert_grp_rx)

    (options_rx, args_rx) = parser_rx.parse_args ()

    if len(args_rx) != 0:
        parser_rx.print_help(sys.stderr)
        sys.exit(1)
    ############# Setting some default values for rx side of the block
    options_rx.rx_freq = 462.5625e6 #setting default rx_freq value
    options_rx.samples_per_symbol =  2
    options_rx.modulation = 'dbpsk'
    options_rx.fusb_block_size = 4096
    options_rx.fusb_nblocks = 16
    options_rx.bitrate = 0.0125e6
    #############
    if options_rx.rx_freq is None:
        sys.stderr.write("You must specify -f FREQ or --freq FREQ\n")
        parser_rx.print_help(sys.stderr)
        sys.exit(1)
    print "printing rx options",options_rx,"&&&&\n"


    # build the graph

    tb = my_top_block(mods[options_tx.modulation],
                     demods[options_rx.modulation],
                     rx_callback,options_tx,
                     options_rx)
    r = gr.enable_realtime_scheduling()
    if r != gr.RT_OK:
       print "Warning: failed to enable realtime scheduling"

    tb.start()
    #tb.rxpath.get_spec_stats(10) #10 is the number of fft frames that we are looking at to determine the average power
    # generate and send packets
    #print "printing megamytes",options_tx.megabytes,"  $$$$\n"
    
    #n = 0
    #pktno = 0
    #pkt_size = int(options_tx.size)
    #options_tx.megabytes = 0.000048
    
    #options_tx.size = 6 #2 bytes for packet size,2 bytes for the synchronization request(including redundant bit) and 2 bits to specify the channel number(including redundant bit)
    
    
    myfile = file("logfile.txt", 'w')
    myfile.write("") 
    #sending sync packet-format 
    global ch
    check =True
    #ch = random.randint(1, 7)#which channel to send information on...this is the second data packet of the synchronization frame
    #resend = 5; #number of times a batch of sync packets is sent on a channel before trying a different channel
    running = True
    #resend_count= 0 #initializing resend count
    sync_pktno = 0
    ch = int(random.choice('17'))
    while running:
  	################################################sync mode####################################
    	if mode == "sync":
    		#nbytes = int(1e6 * .0003)
		#nbytes = int(1e6 * .0003)
		nbytes = 6
    		pkt_size = 6
		data_pktno = 0 
    		print "printing packet size",pkt_size,"pkt size\n"
    		while sync_status != True:
			#ch = random.randint(1, 7)
			ch = int(random.choice('17'))
			
			#ch = random.randint(6,12)
			#ch = 1
		    	hop_freq = float(1e6 * (462.5625+(ch-1)*0.025))#setting the centre freq frequency for sending packets
			tb.rxpath.min_freq = hop_freq - 80e3 
    		    	tb.rxpath.max_freq = hop_freq + 80e3 
			is_present = tb.rxpath.get_spec_stats(1e13,1) #check if primary user is present
			if is_present == True: #if primary user is there then dont transmit on this channel
				continue 
					
			#print "printing status ",status,"\n"
			#print "primary user present = ",is_present,"\n"
			#tb.rxpath.get_spec_stats(10)  
			print "hop freq is ",hop_freq
			
			#hop_freq = float(1e6 * (462.5625+(5-1)*0.05))#setting the centre freq frequency for sending packets
	    		tb.txpath.set_freq(hop_freq)
	    		tb.rxpath.set_freq(hop_freq)
        		#print "inside while pppp printing sync channel",sync_status,"  done"
			#if sync_status == "True":
            		#print "synchronization done..data channel is found"
	    		#break
			#else:
	    		#print "inside else1"
	    		n = 0
	    		
			print >> myfile, "out"
    	    		while n < nbytes:
                	        print >> myfile, "inside while"
                		if options_tx.from_file is None:
                	    		#data = (pkt_size - 2) * chr(sync_pktno & 0xff) #0xff is 255
                	    		data = 's'+'s'+str(ch)+str(ch) #adding redundant bits for sync and channel
	        	    		#print >> myfile, data
                	    		#print "printing data",data,"****\n"
                		else:
            		    		data = source_file.read(pkt_size - 2)
            		    		if data == '':
                	        		break;
	
                		payload = struct.pack('!H', sync_pktno & 0xffff) + data
	       			#print "printing payload",payload,"**\n"
				
                		send_pkt(tb,payload)
				#print "printing payload",payload,"**\n"
                		n += len(payload)
                		sys.stderr.write('.')
                		if options_tx.discontinuous and sync_pktno % 5 == 4:
                	    		time.sleep(1)
                		sync_pktno += 1
	    			#print "before sleeping for 10 seconds and value of resend count is",resend_count
	

	            	time.sleep(0.05)
			#time.sleep(2)
	            	#resend_count += 1 
	    
		print "sync channel found! and it is channel ",ch,"\n"
	    	mode = "traffic"
	   	 #send_pkt(tb,eof=True)
	    	#myfile.close()
	    	#tb.wait()
	################################################end of sync mode####################################

	################################################Communications mode####################################
    	if mode == "traffic":
		nbytes = 16
    	    	pkt_size = 16
		sync_pktno = 0
		while n < nbytes:
                	#print >> myfile, "inside while"
               		if options_tx.from_file is None:
                 		#data = (pkt_size - 2) * chr(data_pktno & 0xff) #0xff is 255
                		data = 'Hi how are you' #Sending this message
	        		#print >> myfile, data
                		#print "printing data",data,"****\n"
                	else:
            		    	data = source_file.read(pkt_size - 2)
            		    	if data == '':
                	        	break;
	
			
                	payload = struct.pack('!14s', data)
	       		#print "printing payload",payload,"**\n"
				
                	send_pkt(tb,payload)
			#print "printing payload",payload,"**\n"
                	n += len(payload)
                	sys.stderr.write('.')
                	if options_tx.discontinuous and data_pktno % 5 == 4:
                		time.sleep(1)
                	data_pktno += 1
	    		#print "before sleeping for 10 seconds and value of resend count is",resend_count
			#time.sleep(0.1)
			tb.rxpath.min_freq = hop_freq - 80e3 
    		    	tb.rxpath.max_freq = hop_freq + 80e3 
			is_present = tb.rxpath.get_spec_stats(1e13,10) #check if primary user is present
			if is_present == True: #if primary user is present then get out of this communication channel, back to sync mode.
				mode = "sync"
				
	################################################ end of Communications mode####################################		



if __name__ == '__main__':
    try:
        main()
    except KeyboardInterrupt:
        pass










































    



